<template>
  <div class="content">
    <ul class="nav nav-tabs my-3" v-if="this.$route.name != 'report-id'">
      <li
        class="nav-item"
        v-for="(nameTeam, index) in teams"
        :key="index"
        @click="setActive(index)"
        :class="{ active: tabselected == index }"
      >
        <a class="nav-link" aria-current="page" href="#"> {{ nameTeam }}</a>
      </li>
    </ul>
    <div>
      <!-- ALL -->
      <div v-if="tabselected === 0">
        <div
          class="card report"
          v-for="(user, index) in listUserHaveTeamAndReport"
          :key="index"
        >
          <div class="card-header d-flex justify-content-between">
            <div class="w-50">
              <img :src="convertAvatar(user.user_id)" class="img" />
              <NuxtLink
                :to="'/user/detail/' + user.user_id"
                class="text-decoration-none"
                >{{ user.name }}</NuxtLink
              >
              of
              <a
                href="#"
                class="text-decoration-none"
                @click="setActive(user.team_id)"
                ><em> {{ convertTeam(user.team_id) }} </em></a
              >
            </div>
            <div>
              <em>{{ user.report_day }}</em>
              <div
                 @click="getIdReport(user.id)"
                  class="btn btn-outline-primary me-1 px-2 py-1"
                  v-if="user.user_id == $auth.user.id"
              >
                <font-awesome-icon far icon="edit" />
              </div>
              <ReportCreateEdit :teamList="listTeam"
                :idReport="idReportEdit"
                v-if="user.user_id == $auth.user.id"
              ></ReportCreateEdit>
            </div>
          </div>
          <div class="card-body content-report">
            <div class="detail-report">
              <p class="menu-report">Công việc đã làm :</p>
              <ul>
                <pre>{{ user.work }}</pre>
              </ul>
              <p class="menu-report">Khó khăn :</p>
              <ul>
                <pre>{{ user.difficult }}</pre>
              </ul>
              <p class="menu-report">Kinh nghiệm :</p>
              <ul>
                <pre>{{ user.experience }}</pre>
              </ul>
              <p class="menu-report">Đề xuất :</p>
              <ul>
                <pre>{{ user.suggest }}</pre>
              </ul>
            </div>
            <div class="comment-content">
              <Comment :user="user"></Comment>
            </div>
          </div>
        </div>
        <!--            -->
        <!--  phân trang-->
        <!--            -->
        <nav aria-label="Page navigation example">
          <ul class="pagination">
            <li class="page-item">
              <a
                class="page-link"
                aria-label="Previous"
                @click="pagination(previous)"
              >
                <span aria-hidden="true">&laquo;</span>
              </a>
            </li>
            <li class="page-item">
              <a class="page-link" href="#">{{ current_page }}</a>
            </li>
            <li class="page-item" @click="pagination(next)">
              <a class="page-link" aria-label="Next">
                <span aria-hidden="true">&raquo;</span>
              </a>
            </li>
          </ul>
        </nav>
      </div>

      <!-- End All -->

      <!-- Team 1 -->
      <div v-for="(team, index) in listTeam" :key="index">
        <div v-if="tabselected === team.id">
          <div
            class="card my-2"
            v-for="user in listUserOfTeam(team.id)"
            :key="user.id"
          >
            <div class="card-header">
              <div class="w-50 d-inline-block">
                <NuxtLink
                  :to="'/user/detail/' + user.user_id"
                  class="text-decoration-none"
                  >{{ user.name }}</NuxtLink
                >
              </div>
              <div class="text-end d-inline-block date-report">
                <em>{{ user.report_day }}</em>
              </div>
            </div>
            <div class="card-body content-report">
              <div class="detail-report">
                <p class="menu-report">Công việc đã làm :</p>
                <ul>
                  <pre>{{ user.work }}</pre>
                </ul>
                <p class="menu-report">Khó khăn :</p>
                <ul>
                  <pre>{{ user.difficult }}</pre>
                </ul>
                <p class="menu-report">Kinh nghiệm :</p>
                <ul>
                  <pre>{{ user.experience }}</pre>
                </ul>
                <p class="menu-report">Đề xuất :</p>
                <ul>
                  <pre>{{ user.suggest }}</pre>
                </ul>
              </div>
              <div class="comment-content">
                <Comment :user="user"></Comment>
              </div>
            </div>
          </div>
          <nav aria-label="Page navigation example">
            <ul class="pagination">
              <li class="page-item">
                <a
                  class="page-link"
                  aria-label="Previous"
                  @click="pagination(previous)"
                >
                  <span aria-hidden="true">&laquo;</span>
                </a>
              </li>
              <li class="page-item">
                <a class="page-link" href="#">{{ current_page }}</a>
              </li>
              <li class="page-item">
                <a
                  class="page-link"
                  aria-label="Next"
                  @click="pagination(next)"
                >
                  <span aria-hidden="true">&raquo;</span>
                </a>
              </li>
            </ul>
          </nav>
        </div>
      </div>
    </div>
    <!-- end team -->
  </div>
</template>

<script>
import ReportCreateEdit from '../report/ReportCreateEdit.vue'
import Comment from '../comment/Comment.vue'
import {
  API_USER,
  API_REPORT,
  API_TEAM,
  AVATAR_MALE,
  AVATAR_FEMALE,
} from '~/assets/contants/contant'
export default {
  components: { Comment, ReportCreateEdit },
  props: [
    'listUserHaveTeamAndReport',
    'previous',
    'next',
    'current_page',
  ],
  data() {
    return {
      listReports: [],
      listUser: [],
      tabselected: 0,
      listTeam: [],
      idReportEdit: null,
    }
  },

   async fetch() {
    this.listTeam = await this.$axios.$get(API_TEAM)
  },
  
  async fetch() {
    ;(this.listReports = await this.$axios.$get(API_REPORT)),
      (this.listUser = await this.$axios.$get(API_USER)),
      (this.listTeam = await this.$axios.$get(API_TEAM))
  },

  methods: {

    
    getIdReport(idReport) {
      this.modal = true
      this.idReportEdit = idReport;
    },
    pagination(url) {
      if (url) {
        fetch(url)
          .then((res) => {
            this.listUserHaveTeamAndReport = res.data
            this.previous = res.prev_page_url
            this.next = res.next_page_url
            this.current_page = res.current_page
          })
      }
    },

    setActive(index) {
      this.tabselected = index
    },

    convertAvatar(id) {
      if (this.listUser.length > 0) {
        const user = this.listUser.find(function (e) {
          return e.id == id
        })
        if (user && user.gender == 0) {
          return AVATAR_MALE
        } else return AVATAR_FEMALE
      }
      return
    },

    convertTeam(team_id) {
      if (this.listTeam.length > 0 && team_id) {
        const team = this.listTeam.find(function (e) {
          return e.id == team_id
        })
        return team.name
      }
      return 'Khác'
    },

    async deleteReport(idReport) {
      if (confirm('Are you sure?')) {
        await this.$axios.$delete(API_REPORT + idReport)
        this.$emit('on-delete-report-success')
      }
    },

    listUserOfTeam(id) {
      let listUserOfTeam
      if (id < 1) {
        listUserOfTeam = this.listUserHaveTeamAndReport
      } else {
        listUserOfTeam = this.listUserHaveTeamAndReport.filter(
          (user) => user.team_id == id
        )
      }
      return listUserOfTeam
    },

    async getReports() {
      this.listReports = await this.$axios.$get(API_REPORT)
    },
    async getUsers() {
     this.listUser = await this.$axios.$get(API_USER)
    },
    async getTeams() {
      this.listTeam = await this.$axios.$get(API_TEAM)
    }
  },

  mounted() {
    this.getReports(),
    this.getUsers(),
    this.getTeams()
  },

  computed: {
    teams() {
      if (this.listTeam) {
        const listTaskTeam = ['All']
        this.listTeam.forEach(function (e) {
          return listTaskTeam.push(e.name)
        })
        return listTaskTeam
      }
      return
    },
  },
}
</script>

<style>
dd {
  padding-left: 40px;
}
.btn-header {
  margin-top: 20px;
}

.btn-header .btn-clear {
  margin-left: 25px;
  width: 50px;
  margin-top: 5px;
}
.date-report {
  width: 45%;
}

.comment-content {
  padding: 10px;
}

.content {
  padding: 0 12px;
}

.report {
  margin-top: 12px;
}

.menu-report {
  margin-bottom: 0;
  padding-left: 20px;
  font-size: 1.1rem;
}
.detail-report pre {
  margin-left: 20px;
}
.content-report pre {
  margin-top: 0;

  font-size: 14px;
  font-weight: 400;
}

.pagination {
  margin-top: 12px;
}

pre{
  word-wrap: break-word;
}
</style>